%function to populate BLh_pudel with observations from COAMPS model, based
%on interp_HPT by A. Borkowski
function [Nw,e_1,Tm,Cm] = COAMPS2TOMO(BLh_pudel_proj_num,dane_NWP,lat_,lon_)
%%%%%%%%%%%%%INPUT%%%%%%%%%%%%%%
%Blh_pudel_proj_num - a 3D grid of points in the middle off tomo voxel
%dane_NWP - structure matrix with each part of structure as one time
%interval. each time interval consist of t_1 - temperature, p_1 - pressure,
%q_1 - mixing ratio. In first also teren_sig - the NMT from COAMPS
%lat_ -latitude of nodes in COAMPS model
%lon_ - longitude of nodes in COAMPS model
%%%%%%%%%%%%OUTPUT%%%%%%%%%%%%%%[(number of points in 3D grid)
%(time_interval)]
%Nw - wet refractivity derived in the center of each voxel based on
%function interp_HPT (Borkowski),
%e - water vapour partial pressure[hPa];
%p - pressure [hPa]
%T - temperature [K]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dane_NWP(25)=[];
n=length(dane_NWP);
n=37;
teren_sig = dane_NWP(1).teren_;
teren_sig = reshape(teren_sig',133*169,1);
if exist('/home/witek/matlab.doc/nachod/Tomo_grid/XYtran.mat')==0
    for i = 1 : length(lat_) 
        [X(i,1),Y(i,1),hh,bbs2,lls2,hhs2,xg,yg,tr_plot] = transform (lat_(i,1),lon_(i,1),teren_sig(i,1),2,3,0);
    end
save('/home/witek/matlab.doc/nachod/Tomo_grid/XYtran.mat','X','Y');
else
    load('/home/witek/matlab.doc/nachod/Tomo_grid/XYtran.mat')
end
size_x = size(X,1);
clear hh bbs2 lls2 hhs2 xg yg tr_plot lat_ lon_
X=X(:);
Y=Y(:);
%%
XYH = reshape(BLh_pudel_proj_num,3,250);
Xtomo = XYH(1,:)';
Ytomo = XYH(2,:)';
Htomo = XYH(3,:)';
clear XYH

sigma = [31050.000; 24400.000; 19400.000; 16050.000; 14300.000; 13300.000; 12425.000; 11675.000; 10925.000; 10175.000; 9425.000; 8675.000; 7800.000; 6800.000; 5800.000; 4800.000; 3900.000; 3100.000; 2300.000; 1600.000; 1100.000; 750.000; 500.000; 330.000; 215.000; 140.000; 90.000; 55.000; 30.000; 10.000];
r_H = [abs(diff(sigma)); 10];
sigma2 = repmat(sigma',size_x,1);
ZI = repmat(teren_sig,30,1);
sigma2 = reshape(sigma2,size_x*30,1);
ZI2 = ZI + sigma2 ;
  X2 = repmat(X,30,1);
  Y2 = repmat(Y,30,1);

  r = 1500;
%to simplyfy and spid up selecting the domain based on maximum and minimum
%points




data_m(n,3)=0;
for j = 1:size(Xtomo,1);
%    for j = 2
 Xmax=max(Xtomo(j))+r;
Ymax=max(Ytomo(j)) + r;
%Zmax=max(Htomo(j)) + r_H(end-j);
Xmin=min(Xtomo(j))-r;
Ymin=min(Ytomo(j))-r;
%Zmin=min(Htomo(j)) - r_H(end-j);


    for i=1:n
        t_1 = dane_NWP(1,i).t_sig - 273.15;
        p_1 = dane_NWP(1,i).p_sig;
        q_1 = dane_NWP(1,i).q_sig;

        data=[X2 Y2 ZI2 p_1 t_1 q_1];
        data(data(:,1)<Xmin,:)=[];
        data(data(:,2)<Ymin,:)=[];
        data(data(:,1)>Xmax,:)=[];
        data(data(:,2)>Ymax,:)=[];
        [Heig,number] = sort(abs(data(:,3) - Htomo(j)),1);
        data(number(9:end),:) =[];
        clear Heigh number
           %to see point cloud used to interpolate
    %     figure(j)
     %    scatter3(Ytomo(j), Xtomo(j), Htomo(j),50,'r','filled')
      %   hold on 
       %  scatter3(data(:,2), data(:,1),data(:,3),50,'filled')
        data_out = interp_HPT(data, [Xtomo(j) Ytomo(j) Htomo(j)]);
        %data_check = interp_HPT(data, [data(1,1) data(1,2) data(1,3)]);
        %data_check  = data_check - data(1,:)
        
        %data_m=[data_m; data_out(4:end)];
        data_m(i,:)=data_out(4:end);
        clear data
       % keyboard
    end
%cisnienie
Cm(:,j)=data_m(:,1);
%temperatura
T=data_m(:,2);
Tm(:,j)=T;
%wilgotnosc
Wm=data_m(:,3);
 td=mr2td(Wm*1000,Cm);
 td=td(:);
 %Wm=td2hum(td,Tm+273.15);
 e_1(:,j) = t2es(td);
 e = e_1(:,j);
 Nw(:,j) = eT2NwCOAMPS(e,T+273.15);
 clear td  Wm data_m T e
end
 e_1 = e_1';
 Nw = Nw';
 Tm = Tm';
 Cm = Cm';
