%Neill mapping function - no need for meteorological data - B required
function   m = NEILL_wet_map( elewacja , B )
%______________INPUT______________
% elewacja - elavation in radians [rad]
% B - latitude in radians [rad]
%______________OUTPUT______________
% m - the wet mapping function [-]
B = B * 180/pi();
NEILL.B_15(1)=5.8021897*10^-4; NEILL.B_30(1)=5.6794847*10^-4;   NEILL.B_45(1)=5.8118019*10^-4;  NEILL.B_60(1)=5.9727542*10^-4;  NEILL.B_75(1)=6.1641693*10^-4;
NEILL.B_15(2)=1.4275268*10^-5;  NEILL.B_30(2)=1.5138625*10^-5;  NEILL.B_45(2)=1.4572752*10^-5;  NEILL.B_60(2)=1.5007428*10^-5;  NEILL.B_75(2)=1.7599082*10^-5;
NEILL.B_15(3)=4.3472961*10^-2;  NEILL.B_30(3)=4.6729510*10^-2;  NEILL.B_45(3)=4.3908931*10^-2;  NEILL.B_60(3)=4.4626982*10^-2;  NEILL.B_75(3)=5.4736038*10^-2;

wB = length(B);
we = length(elewacja);
for i = 1 : wB
    for j = 1 : we

       if B(i,1)>=15&B(i,1)<30
             a1=NEILL.B_15(1);
             b1=NEILL.B_15(2);
             c1=NEILL.B_15(3);
             a2=NEILL.B_30(1);
             b2=NEILL.B_30(2);
             c2=NEILL.B_30(3);
             Bminus=15;
         elseif B(i,1)>=30&B(i,1)<45
             a1=NEILL.B_30(1);
             b1=NEILL.B_30(2);
             c1=NEILL.B_30(3);
             a2=NEILL.B_45(1);
             b2=NEILL.B_45(2);
             c2=NEILL.B_45(3);
             Bminus=30;
         elseif B(i,1)>=45&B(i,1)<60;
             a1=NEILL.B_45(1);
             b1=NEILL.B_45(2);
             c1=NEILL.B_45(3);
             a2=NEILL.B_60(1);
             b2=NEILL.B_60(2);
             c2=NEILL.B_60(3);
             Bminus=45;
        elseif B(i,1)>=60&B(i,1)<=75;
             a1=NEILL.B_60(1);
             b1=NEILL.B_60(2);
             c1=NEILL.B_60(3);
             a2=NEILL.B_75(1);
             b2=NEILL.B_75(2);
             c2=NEILL.B_75(3);
             Bminus=60;
         else B(i,1)>75
             'blad poza zakresem'
         end
         a=a1+((a2-a1)/15)*(B(i,1)-Bminus);
         b=b1+((b2-b1)/15)*(B(i,1)-Bminus);
         c=c1+((c2-c1)/15)*(B(i,1)-Bminus);
         m(j,i)=(1+a/(1+b/(1+c)))/(sin(elewacja(j,i))+(a/(sin(elewacja(j,i))+(b/(sin(elewacja(j,i))+c)))));
         clear a a1 a2 b b1 b2 c c1 c2 Bminus;
    end
end