function  [tropos,er] = Saastamoinen_ZHD_gard(p,B,H) %function designed to calculate Zenith Hydrostatic Delay from Saastamoinen equation and it's bias
%it's been recognized that function is not computational - efficience but
%to keep everything which is linked with Delay Estimation in one place has been coded in this way.
if isnan(p) == 1 | isnan(B)==1 | isnan(H)==1
    tropos = NaN;
    er = NaN;
else
%pretty(biass)
mB = 0.005; %assumed plannar accuracy in north south direction [m]
mH = 0.05;  %assumed height accuracy
mp = 0.56;  %GPT pressure accuracy based on :J. Boehm, R. Heinkelmann, and H. Schuh (2006), Global Pressure and Temperature (GPT): A spherical harmonics expansion of annual pressure and temperature variations for geodetic applications, submitted to Journal of Geodesy
%mp = 0.3    %based on equipment producer tests - for LOCAL parameters

%(subs(Bcoef))^2
tropos=(0.002267*p)/(1-0.00266*cos(2*(B))-0.00000028*H);
%--------------------------------------------------------------------------
%ppn=999.85:0.01:1000.15;
ppn=(p-0.15):0.01:(p+0.15);
%BBn=54.9985:0.0001:55.0014;
BBn=(B-0.0015):0.0001:(B+0.0014);
%BBn=BBn*180/pi;
%HHn=999.95:0.003:1000.04;
HHn=(H-0.05):0.003:(H+0.05);
[pn,Bn,Hn]=meshgrid(ppn,BBn,HHn);
tropos_grad=(0.002267*pn)./(1-0.00266*cos(2*(Bn))-0.00000028*Hn); %Saastamoinen equation

%[gradp,gradB,gradH]=gradient(tropos_grad,0.01,0.0000045*180/pi,0.003);
[gradp,gradB,gradH]=gradient(tropos_grad,0.01,0.0000045*180/pi,0.005);
grady=[gradp(1) gradB(1) gradH(1)];
bledy=[mp mB mH];

er=sqrt(grady*diag(bledy.^2)*grady');
end