
function  [tropom, err]=Saastamoinen_ZWD_gard(T,e)
%function designed to calculate Zenith Wet Delay from Saastamoinen equation
%and it's uncertainity
%updated 5.05.2008
%mT - switched from 0.3 to 2 i order to compromise between models and local
%observations
%meproc - switched from 3 to 15 in order to compromise between models and
%local
%it's been recognized that function is not computational - efficient but
%to keep everything which is linked with Delay Estimation in one place has been coded in this way.
if isnan(T) == 1 | isnan(e) == 1
    tropom = NaN;
    err = NaN;
else
%mT = 2.96;  %GPT temperature accuracy based on J. Boehm, R. Heinkelmann, and H. Schuh (2006), Global Pressure and Temperature (GPT): A spherical harmonics expansion of annual pressure and temperature variations for geodetic applications, submitted to Journal of Geodesy
mT = 2;   %based on equipment producer tests for LOCAL;
%meproc = 35; %assumed water vapour accuracy in [%] MODEL BERG
meproc = 15; % water vapour accuracy in [%] based on equipment producer tests for LOCAL
es = t2es(T); %to calculate saturated air water vapour partial pressure
e = es * e/100; %to switch from % to mb.
me = meproc * es / 100; % water vapour bias in term of partial pressure [hPa]
tropom = 0.002277*((1255/T)+0.05)*e;
%---------------------------------
TTn=(T-0.15):0.01:(T+0.15);
%BBn=54.9985:0.0001:55.0014;
%een=(me - 5*es/100):0.0215:(me + 5*es/100);
een=(e - me/2):0.0215/2:(e + me/2);
[Tn,en]=meshgrid(TTn,een);
tropom_grad = 0.002277*((1255./Tn)+0.05).*en; %Saastamoinen equation

%[gradp,gradB,gradH]=gradient(tropos_grad,0.01,0.0000045*180/pi,0.003);
[gradT,grade]=gradient(tropom_grad,0.01,0.011);
grady=[gradT(1) grade(1)];
bledy=[mT me];
err=sqrt(grady*diag(bledy.^2)*grady');
end