function [elewacja, azi] = elewacja_azymut_mod(B, L, SP3X, SP3Y, SP3Z) 
% function to calculate elevation and azimuth of satelites for given
% station coordinates and given satelite coordinates
%_________________INPUT________________
% B - latitude [rad] 
% L - longitude [rad]
% SP3X - satellite X coordinate in ECEF [m]
% SP3Y - satellite Y coordinate in ECEF [m]
% SP3Z - satellite Z coordinate in ECEF [m]
%_________________OUTPUT________________
% elewacja - elevation [rad]
% tab - azimuth [rad]
%
%load('sp3_new')
%B = 51
%L = 17
%SP3X(1,:)=[];
%SP3Y(1,:)=[];
%SP3Z(1,:)=[];
%clear i j;
for i=1:length(B)
    lat=B(i)*180/pi; long=L(i)*180/pi;
    [X,Y,Z] = BLH2XYZ (B,L,0);
    xyz=[X Y Z];
    elewacja(:,i)=FindElevation(SP3X,SP3Y,SP3Z,xyz(i,:));
    [e n u]=xyz2enu(B,L,xyz(1,1),xyz(1,2),xyz(1,3));
    %n=n+20000;
    %u=u-6373000
    %e=0;
    %n=0;
    %u=0;
    enusta(i,:)=[e n u]; 
    
    %clear e n u;
    for j=1:length(SP3X) 
    deltau=SP3X(j)-xyz(i,1);
    deltav=SP3Y(j)-xyz(i,2);
    deltaw=SP3Z(j)-xyz(i,3);
    deltauvw=[deltau, deltav, deltaw];
    [e n u]=xyz2enu(B,L,SP3X(j),SP3Y(j),SP3Z(j));
    enusat(j,:)=[e n u];
    enh = enusta(i,:) - enusat(j,:);   
    neh = [enh(1,2) enh(1,1) enh(1,3)];
    neh = neh(:);
n = neh(1,1);
e = neh(2,1);
h = neh(3,1);
%tab2(j,i) = atan(e/n)*180/pi;
if elewacja(j,i) < 0
    azi = NaN;
    elewacja = NaN
elseif (n > 0) & (e > 0)
    azi = atan(e/n);
elseif (n < 0) & (e > 0)
    azi = pi-abs(atan(e/n));
elseif (n < 0) & (e < 0)
    azi = pi+abs(atan(e/n));
elseif (n > 0) & (e < 0)
    azi = 2*pi-abs(atan(e/n));
elseif (n >= 0) & (e == 0)
    azi = 0;
elseif (n < 0) & (e == 0)
    azi = pi;
elseif (n == 0) & (e > 0)
    azi = pi/2;
elseif (n == 0) & (e < 0)
    azi = 3*pi/2;
end

azi;
    %clear e n u;
    %deltauvwc=enusat-enusta;
    %deltauvw=[deltauvwc(:,2) deltauvwc(:,1) deltauvwc(:,3)];
    %lat=lat*pi/180; long=long*pi/180;
    %azi=Az(lat,long,deltauvw);
    %azi=azi*180/pi;
    tab(j,i)=azi*180/pi;
  end
end
clear azi
azi = tab;
elewacja=elewacja*180/pi;

clear deltau deltav deltaw deltauvw neh e n h X Y Z xyz lat long  SP3Z SP3Y SP3clc SP3time SP3Y enh enusat enusta;
