%function designed to analyticaly derive intersection points between the
%Voxel model and the ray path (no bending!!!!)
function [par,SWD_mod] = inter_plane_line(BLh_pudel_proj,stacja,nr,czas,sat)
%____________changes:
%21.08.2009 the data without SWD will not be considered. 
%18.06.2008 stacja has changes it's construction now its stacja(czas).h(nr). 
%which means that for each hour there is a set of observations station 
%parameters and so on 
%26.06.2008 the BLh_pudel_proj are now in 1992 coordinates so there is a
%need to change basic projection of station ellipsoidal coordinates into 92
%projection 
%20.08.2009 the addtional parameter for cutting off part of the delay
%assigned to part is outside the model.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
%BLh_pudel_proj - projected 3D Voxel model
%stacja - the structure matrics containig all observations
%czas - the time in epochs from the starting point
%sat - number of satellite in stacja matrcis(not always PRN)
%nr - number of station to be processed
%Output:
%par - sorted in ascending mode the intersection points and the station
%coordinates.


%xyz_inter - intersection point.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% d - distance in the vicinity to the network - simply second point for the
% line equation - where the first one is a station - to avoid recalculation
% of satellite position.
d = 55000;
% Second points coordinates

Bfin = cos(stacja(czas).h(nr).satellite(sat).azi*pi()/180)*d*cos(stacja(czas).h(nr).satellite(sat).elewacja*pi()/180);
SWDcz = stacja(czas).h(nr).satellite(sat).SWD;
if isnan(SWDcz)==0 
Lfin = sin(stacja(czas).h(nr).satellite(sat).azi*pi()/180)*d*cos(stacja(czas).h(nr).satellite(sat).elewacja*pi()/180);
hfin = sin(stacja(czas).h(nr).satellite(sat).elewacja*pi()/180)*d;
% Basic projection- change to 92 projection!!!
[Bsta,Lsta,hsta,bbs2,lls2,hhs2,xg,yg,tr_plot] = transform (stacja(czas).h(nr).parameters(1,2),stacja(czas).h(nr).parameters(1,3),stacja(czas).h(nr).parameters(1,4),2,3,0);
clear bbs2 lls2 hhs2 xg yg tr_plot
Bfin = Bsta + Bfin;
Lfin = Lsta + Lfin;
hfin = hsta + hfin;
% to overcome round off error the 92 coordinates are changed into local
%minB_pudel = 0.8*min(BLh_pudel_proj(1,:));
%minL_pudel = 0.8*min(BLh_pudel_proj(2,:));
%BLh_pudel_proj(1,:) = BLh_pudel_proj(1,:) - minB_pudel;
%BLh_pudel_proj(2,:) = BLh_pudel_proj(2,:) - minL_pudel;
%Bsta = Bsta - minB_pudel;
%Bfin = Bfin - minB_pudel;
%Lsta = Lsta - minL_pudel;
%Lfin = Lfin - minL_pudel;
%
xyz_a = [Bsta;Lsta;hsta;];
xyz_b = [Bfin;Lfin;hfin;];
[wier,kol,poz] = size(BLh_pudel_proj);
% Loop for B change
for w = 1 : sqrt(kol)
xyz0 = [BLh_pudel_proj(1,w,1); BLh_pudel_proj(2,1,1); BLh_pudel_proj(3,1,1)];
xyz1 = [BLh_pudel_proj(1,w,1); BLh_pudel_proj(2,kol,1); BLh_pudel_proj(3,1,1)];
xyz2 = [BLh_pudel_proj(1,w,1); BLh_pudel_proj(2,1,1); BLh_pudel_proj(3,1,poz)];
Sol= (xyz_a - xyz0);
plane_co = [xyz_a - xyz_b xyz1 - xyz0 xyz2-xyz0];
par = plane_co^-1*Sol;
       if par(1,1) > 0  
        xyz_inter_B(w,1:3) = xyz_a + (xyz_b - xyz_a)*par(1,1);
        xyz_inter_B(w,4) = sqrt((xyz_inter_B(w,1) - xyz_a(1,1))^2 +  (xyz_inter_B(w,2) - xyz_a(2,1))^2 +(xyz_inter_B(w,3) - xyz_a(3,1))^2);
       else 
        xyz_inter_B(w,:) = [NaN NaN NaN 0];
       end
%figure(2)
%scatter3(Bfin,Lfin,hfin,10,'b');
%hold on
%scatter3(Bsta,Lsta,hsta,10,'r');
%scatter3(xyz0(1,1),xyz0(2,1),xyz0(3,1),20,'m');
%scatter3(xyz1(1,1),xyz1(2,1),xyz1(3,1),20,'m');
%scatter3(xyz2(1,1),xyz2(2,1),xyz2(3,1),20,'m');
%scatter3(xyz_inter_B(w,1),xyz_inter_B(w,2),xyz_inter_B(w,3),30,'g');
%xlabel('B');
%ylabel('L');
%zlabel('h');
%legend('target','station','net points', 'intersection')
clear xyz0 xyz1 xyz2 par plane_co Sol 
end
clear w

%Loop for L change
licz = 0;
for w = 1 : sqrt(kol)+1 : kol
    licz = licz + 1 ;
xyz0 = [BLh_pudel_proj(1,1,1); BLh_pudel_proj(2,w,1); BLh_pudel_proj(3,1,1)];
xyz1 = [BLh_pudel_proj(1,sqrt(kol),1); BLh_pudel_proj(2,w,1); BLh_pudel_proj(3,1,1)];
xyz2 = [BLh_pudel_proj(1,1,1); BLh_pudel_proj(2,w,1); BLh_pudel_proj(3,1,poz)];
Sol= (xyz_a - xyz0);
plane_co = [xyz_a - xyz_b xyz1 - xyz0 xyz2-xyz0];
par = plane_co^-1*Sol;
       if par(1,1) > 0 
        xyz_inter_L(licz,1:3) = xyz_a + (xyz_b - xyz_a)*par(1,1);
        xyz_inter_L(licz,4) = sqrt((xyz_inter_L(licz,1) - xyz_a(1,1))^2 +  (xyz_inter_L(licz,2) - xyz_a(2,1))^2 +(xyz_inter_L(licz,3) - xyz_a(3,1))^2);  
       else 
        xyz_inter_L(licz,:) = [NaN NaN NaN 0];
       end
%figure(2)
%scatter3(Bfin,Lfin,hfin,10,'b');
%hold on
%scatter3(Bsta,Lsta,hsta,10,'r');
%scatter3(xyz0(1,1),xyz0(2,1),xyz0(3,1),20,'m');
%scatter3(xyz1(1,1),xyz1(2,1),xyz1(3,1),20,'m');
%scatter3(xyz2(1,1),xyz2(2,1),xyz2(3,1),20,'m');
%scatter3(xyz_inter_L(licz,1),xyz_inter_L(licz,2),xyz_inter_L(licz,3),30,'g');
%xlabel('B');
%ylabel('L');
%zlabel('h');
%legend('target','station','net points', 'intersection');
clear xyz0 xyz1 xyz2 par plane_co Sol
end
clear w

%Loop for h change
for w = 1 : poz
xyz0 = [BLh_pudel_proj(1,1,1); BLh_pudel_proj(2,1,1); BLh_pudel_proj(3,1,w)];
xyz1 = [BLh_pudel_proj(1,sqrt(kol),1); BLh_pudel_proj(2,1,1); BLh_pudel_proj(3,1,w)];
xyz2 = [BLh_pudel_proj(1,1,1); BLh_pudel_proj(2,kol,1); BLh_pudel_proj(3,1,w)];
Sol= (xyz_a - xyz0);
plane_co = [xyz_a - xyz_b xyz1 - xyz0 xyz2-xyz0];
par = plane_co^-1*Sol;
       if par(1,1) > 0 
        xyz_inter_h(w,1:3) = xyz_a + (xyz_b - xyz_a)*par(1,1);
        xyz_inter_h(w,4) = sqrt((xyz_inter_h(w,1) - xyz_a(1,1))^2 +  (xyz_inter_h(w,2) - xyz_a(2,1))^2 +(xyz_inter_h(w,3) - xyz_a(3,1))^2);
       else 
        xyz_inter_h(w,:) = [NaN NaN NaN 0];
       end
%figure(2)
%scatter3(Bfin,Lfin,hfin,10,'b');
%hold on
%scatter3(Bsta,Lsta,hsta,10,'r');
%scatter3(xyz0(1,1),xyz0(2,1),xyz0(3,1),20,'m');
%scatter3(xyz1(1,1),xyz1(2,1),xyz1(3,1),20,'m');
%scatter3(xyz2(1,1),xyz2(2,1),xyz2(3,1),20,'m');
%scatter3(xyz_inter_h(w,1),xyz_inter_h(w,2),xyz_inter_h(w,3),30,'g');
%xlabel('B');
%ylabel('L');
%zlabel('h');
%legend('target','station','net points', 'intersection');
clear xyz0 xyz1 xyz2 par plane_co Sol
end
clear par

%Last refinements - sorting, excluding points outside the model
xyz_a = [xyz_a' 0];
par = [xyz_a; xyz_inter_h;  xyz_inter_B;  xyz_inter_L];
[wi,ki,wa] = find(isnan(par(:,1))==0);
par = par(wi,:);
clear wi ki wa
%above the model
    [wi,ki,wa] = find(par(:,3)<=BLh_pudel_proj(3,1,poz));
    par = par(wi,:);
    clear wi ki wa
%to far north
    [wi,ki,wa] = find(par(:,1)<=BLh_pudel_proj(1,kol,1));
    par = par(wi,:);
    clear wi ki wa
%to far south
    [wi,ki,wa] = find(par(:,1)>=BLh_pudel_proj(1,1,1));
    par = par(wi,:);
    clear wi ki wa
%to far east
    [wi,ki,wa] = find(par(:,2)<=BLh_pudel_proj(2,kol,1));
    par = par(wi,:);
    clear wi ki wa
%to far west
    [wi,ki,wa] = find(par(:,2)>=BLh_pudel_proj(2,1,1));
    par = par(wi,:);
    clear wi ki wa

par = sortrows(par,4);
        
%function to take into account rays comming not out of the
                %top of the model
                    if par(end,3) < BLh_pudel_proj(3,1,end);
                      [SWD_mod] = cut_SWD(par(end,3),stacja(czas).h(nr).satellite(sat).elewacja);
                    else
                        SWD_mod = 0;
                    end
%figure(2)
%plot3([Bsta; Bfin],[Lsta; Lfin], [hsta; hfin], 'r')
%to back to 92 coordinates
%par(:,1) = par(:,1) + minB_pudel;
%par(:,2) = par(:,2) + minL_pudel;
else
 par=[NaN NaN NaN NaN];
 SWD_mod = 0;
end
