function [data_out] = interp_HPT(data_in, XYH)

% interpolacja wilgotnoci (h), cinienia (p) i temperatury (t)
% w punktach XYH; kolejno wartoci: X, Y, H
% na podstawie wartoci podanych w tabeli data_in
% kolejno kolumn: X, Y, H, cinienie, temperatura, wilgotno
% jeli brak danych naley wstawi 'NaN'
% Kolejno wartoci w danych wyjciowych, data_out taka sama


% interpolacja temperatury 
data = data_in;
data(isnan(data(:,5)),:) = [];
[n m] = size(data);
u(1:n) = 1;
u = u(:);
H = u*XYH(:,3)';
k = length(XYH(:,3))';
clear u 
u(1:k) = 1;
w = H - data(:,5)*u;
w = w.^-4;
w(isinf(w)) = 10^20;
T = data(:,5)'*w;
v = sum(w,1);
T = T./v;
T = T(:);
% interpolacja wilgotnoci
clear u v w
data = data_in;
data(isnan(data(:,6)),:) = [];
[n m] = size(data);
u(1:n) = 1;
u = u(:);
v(1:k) = 1;
dx = u*XYH(:,1)'-data(:,1)*v;
dy = u*XYH(:,2)'-data(:,2)*v;
dh = u*XYH(:,3)'-data(:,3)*v;
w = dx.^2+dy.^2+dh.^2;
w = 1./w;
w(isinf(w)) = 10^20;
h = data(:,6)'*w;
v = sum(w,1);
h = h./v;
h = h(:);
%interpolacja cinienia
clear u v 
data = data_in;
data(isnan(data(:,4)),:) = [];
[n m] = size(data);
u(1:n)=1;
u=u(:);
v(1:k) = 1;
dh = -u*XYH(:,3)'+data(:,3)*v;
w=log10(data(:,4))+dh/18400./(1+data(:,5)/273);
p=10.^w;
%keyboard
p=mean(p);

%disp(h)
data_out = [XYH, p, T, h];
%keyboard