function [equa_P,equa_PC, xP, xC, xPC] = tomo1(stacja_model,BLh_pudel_proj,BLh_pudel_proj_num)
%%%%%______________________The inverse over the model________________%%%%
%changes:
%25.08.09 due to changes in stacja_model change in code.
%This is the first version of tomography model inversion system 18.06.2008
%_______________________INPUT______________________________
%stacja_model - the struct variable with (n) stations, (h) hours,
%(sat) satellites, in each PRN, elevation, azi SWD, MSWD
%BLh_pudel_proj - the voxel model projected into planar face (vertices)
%BLh_pudel_proj_num - the voxel modelthe center point of each voxel 
%______________________OUTPUT_____________________________
%x - the wet refractivity without any weighting nor constrains
%xP - the wet refractivity obtained using pseudo inverse
%xC - the wet refractivity obtained using constrains
%xPC - the wet refractivity obtained using pseudoinverse and constrains
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[wie,czas_st] = size(stacja_model);
clear wie
[ile,ko,ile_wys] = size(BLh_pudel_proj_num);
%set time loop
clear ile
ile = sqrt(ko);
czas = 0;
while czas <czas_st
    czas = czas + 1;
    b = 0;
    stac=size(stacja_model(czas).h,2);
    A(ile*ile*ile_wys,31*stac) = 0;
    N(ile*ile*ile_wys,31*stac) = 0;
    %setting the satelite loop 
    sat = 0;
    sat_numer = 1;
    for nr = 1:stac
        sat_numer = length(stacja_model(czas).h(nr).satellite);
      while sat < sat_numer
        sat = sat + 1;
        %setting the station loop
            b = b + 1;
            % calculations of plane - line intersection (no bending!) pure
            % analytical
            par = inter_plane_line(BLh_pudel_proj,stacja_model,nr,czas,sat);
                if isnan(par)==0
                %deriving the box number (num_pud) from par and
                %distance (diff_d)
                [num_pud,diff_d,Dsr] = set_num_pud(BLh_pudel_proj_num,BLh_pudel_proj,par);
                num_pud_nie = Apuste(num_pud,ile*ile*ile_wys);
                N(:,b) = num_pud_nie; 
                A(num_pud,b) = diff_d/1000;
                %P(b,1) = stacja(nr).h(czas).satellite(sat).M_SWD*1000;
                P(b,1) =1; 
                SWD(b,1) = stacja_model(czas).h(nr).satellite(sat).SWD*1000;
                end
      end
     sat = 0;
    end
     %data input filtration   
        [wi,ki,wa] = find(SWD==0);
        SWD(wi,:) = [];
        P(wi,:) = [];
        A(:,wi) =[];
        N(:,wi) =[];
        clear wi ki wa
        [wi,ki,wa] = find(isnan(SWD)==1);
        SWD(wi,:) = [];
        P(wi,:) = [];
        A(:,wi) =[];
        N(:,wi) =[];
        clear wi ki wa
        [wi,ki,wa] = find(mean(A)==0);
        A(:,ki) =[];
        N(:,ki) =[];
        clear wi ki wa
        P = diag(P.^2);
        Ap = A';
        A = Ap;
        Ap((end+1):ile*ile,:) = 0;
        %pseudoinverse solution without any constrains
        xP(czas,:) = pinv(A'*A)*A'*SWD;
        %_________________________________________
       equa_P(czas).A = A;
       equa_P(czas).SWD = SWD;
        % introducing vertical smoothing based on present radiosonde data
        %    load radio_all.mat
        %    [B] =versmooth(czas,data_d,BLh_pudel_proj_num);
         %introducing horizontal smoothing
            [wie,kol] = size(N);
            Nide(1:wie,1) = 1:wie;
            Nide = Nide * kol;
            N = sum(N,2);
            R = Nide - N; 
            clear wie ko
            [wie,ko,war] = find(R==0);
            clear R
            %R = wie;% change in order to test the need of extra equations
             R = (1:ile*ile*ile_wys);
             R = R';
            [Hor] = horsmooth(R,BLh_pudel_proj_num,ile);
            [wH,kH,waH] = size(Hor);
            A = [A;Hor];
            %SWD = [SWD; 1;zeros(ile*ile*ile_wys,1)];
            SWDr = SWD;
            SWD = [SWD; zeros(wH,1)];
            Pr = diag(P);
            P = diag(P);
            %P = [P;1;ones(ile*ile*ile_wys,1)];
            P = [P;ones(wH,1)];
            equa_PC(czas).P = P;
            P = diag(P);
            
%        xP(czas,:) = (A'*P*A+B)^-1*A'*P'*SWD;
       
       %classic inversion with constrains
         xC(czas,:) = (A'*P*A)^-1*A'*P'*SWD;
        %_________________________________
        
        % other type of solution with direct use of SVD
         [U,S,V] = svd(A'*P*A,0);
          Xpsvd = (V*S^-1*U')*A'*P'*SWD;
        %____________________________________
        
        %pseudoinverse solution with constrains
         xPC(czas,:) = pinv(A'*P*A)*A'*P'*SWD;
        %__________________________________
        
         equa_PC(czas).A = A;
         equa_PC(czas).SWD = SWD;
         %xPP(czas,:) = (Ap'*Pr*Ap + 2*Hor'*Hor)^-1*Ap'*Pr'*SWD;
         %[U,S,V] = svd(A'*P*A); % singular value decomposition
         % U - the orthonoraml N X N eigencvectors of the data space
         % S - N x M diagonal eigenvalues matrix arranged in decreasing
         % order
         % V - M x M eigenvectors of the parameter space 
         
        clear A P SWD Ap wi ki wa U S V Hor 
end
