clear all
close all
load('data_cal.mat')
begdate=data1_M.part(1,4);
T_538=(data538.part(:,4) - begdate)./60;
T_1_M=(data1_M.part(:,4) - begdate)./60;
[plea, a, b] = intersect(data538.part( :, 4),data_REF_P.part( : , 2));
calibrate=[data538.part( a ,3)  data_REF_P.part(b , 1)];
differencies=calibrate(:,1) - calibrate(:, 2);% difference between wrong and model
differencies=differencies';
[f,p]=tpaps([data538.part(:,1)'; data538.part(:,2)'],differencies, 0.7)
p_model=fnval(f,[data538.part(a,1)'; data538.part(a,2)']);
bias_model = round(mean(p_model - differencies)*100)/100
error_model = round(std(p_model - differencies)*100)/100
%unsortedREF = data_REF_P.part( b , 1 );
%[sortedREF,num] = sort(calibrate( : , 2 ));
%[sorted538, num538] = sort(data538.part( a ,3));
%unsorted538 = data538.part(a , 3);
%calibrate_sort=[unsorted538(num) sortedREF];
figure(1)
title('Calibration of pressure sensor')
h1=subplot(3,1,1);

plot(h1,T_538,differencies,'.r')
hold on
plot(h1,T_538,p_model,'.m')
title(h1,'Diference between reference and obtained')
legend(h1,'observed 538', 'modeled 538')
xlabel(h1,'time[h]')
ylabel(h1,'pressure difference [hPa]');
h2=subplot(3,1,2);
plot(h2,T_538,data538.part(:,1),'.r')
title(h2,'Temperature in time')
xlabel(h2,'time[h]')
ylabel(h2,'temperature [deg C]')
h3=subplot(3,1,3);
plot(h3,T_538,data538.part(:,2),'.r')
title(h3,'Humidity in time')
xlabel(h3,'time[h]')
ylabel(h3,'humidity [%]')
figure(2)
j1=subplot(2,1,1);
plot(j1, data538.part(:,1),differencies,'r.')
title(j1,'Corelation between differencies in pressure and temperature')
xlabel(j1,'temperature [deg C]')
ylabel(j1,'pressure difference [hPa]')
j2 = subplot(2,1,2);
plot(j2, data538.part(:,2),differencies,'r.')
title(j2, 'Corelation between differencies in pressure and humidity')
xlabel(j2 ,'humidity [%]')
ylabel(j2, 'pressure difference [hPa]')

%figure(3)
%plot(sorted538, unsortedREF(num538),'.m');

