%Script for continous wavelet transform analysis.
%To properly run this script, otehr toolbox is needed - WaveLab802.
%This script is part of TSProg toolbox, by Marcin Zajac

% Set wavelet name, scales, and number voices.
%Avaliable wavlets : 'Gauss', 'DerGauss','Sombrero', 'Morlet'
wavelet = 'Morlet';

nvoice = 2;
scale = 64;
oct = 2;


plot1 = findobj( 'Tag', 'plotN' );		%Getting stored data
plot2 = findobj( 'Tag', 'plotE' );
plot3 = findobj( 'Tag', 'plotH' );


data1 = get( plot1, 'UserData' );		%continue getting data
data2 = get( plot2, 'UserData' );
data3 = get( plot3, 'UserData' );


% Continuous analysis and plot for component 1.

figure; 
cwx1 = CWT_Wavelab(data1,nvoice,wavelet,oct,scale);
plot(cwx1);
ax = gca; 
colorbar;
axTITL = get(ax,'title');
axXLAB = get(ax,'xlabel');
data1.Layer7 = cwx1;
set( plot1, 'UserData', data1 );

% Continuous analysis and plot for component 2.
figure; 
cwx2 = CWT_Wavelab(data2,nvoice,wavelet,oct,scale); 
plot(cwx2);
ax = gca; 
colorbar;
axTITL = get(ax,'title');
axXLAB = get(ax,'xlabel');
data2.Layer7 = cwx2;
set( plot2, 'UserData', data3 );


% Continuous analysis and plot for component 3.
figure; 
cwx3 = CWT_Wavelab(data3,nvoice,wavelet,oct,scale); 
plot(cwx3);
ax = gca; 
colorbar;
axTITL = get(ax,'title');
axXLAB = get(ax,'xlabel');
data3.Layer7 = cwx3;
set( plot3, 'UserData', data3 );